@Echo Off
Rem Asm.bat - 0.0.0

Rem -=- Notes -=-
Rem 24MLib and 32MLib both use Lib32A (Borland)

Rem -=- Error Checking: Arguments -=-
If %3x==x Goto EArg
If Not Exist %2.asm Goto ENoAsmFile

Rem -=- Cleanup -=-
If Exist %2.obj Del %2.obj
If Exist %2.lst Del %2.lst
If Exist %2.exe Del %2.exe
If Exist %2.map Del %2.map
If Exist %2.crf Del %2.crf
If Exist %2.lib Del %2.lib
If Exist %4.obj Del %4.obj
If Exist %4.res Del %4.res
If Exist %2_2.lst Del %2_2.lst
If Exist %2_2.map Del %2_2.map
If Exist LOut.txt Del LOut.txt
If Exist AOut.txt Del AOut.txt
If Exist CpOut.txt Del CpOut.txt
If Exist CvOut.txt Del CvOut.txt
If Exist LibOut.txt Del LibOut.txt

Rem -=- Goto Label for Options -=-
Rem Windows with Resource
If %4x==x Goto LNoResource
If Not Exist %4.rc Goto ENoResFile
If %1==32MExeN Goto L32MExeNRes
If %1==32MExeS Goto L32MExeSRes
If %1==32MExeF Goto L32MExeFRes
If %1==32MObjN Goto L32MObjNRes
If %1==32MObjS Goto L32MObjSRes
If %1==32MObjF Goto L32MObjFRes
If %1==32MDllN Goto L32MDllNRes
If %1==32MDllS Goto L32MDllSRes
If %1==32MDllF Goto L32MDllFRes
If %1==32MCExeN Goto L32MCExeNRes
If %1==32MCExeS Goto L32MCExeSRes
If %1==32MCExeF Goto L32MCExeFRes
Goto EArg
:LNoResource
Rem Dos 16-Bit
If %1==16TLibN Goto L16TLibN
If %1==16TLibS Goto L16TLibS
If %1==16TLibF Goto L16TLibF
If %1==16TObjN Goto L16TObjN
If %1==16TObjS Goto L16TObjS
If %1==16TObjF Goto L16TObjF
If %1==16TExeN Goto L16TExeN
If %1==16TExeS Goto L16TExeS
If %1==16TExeF Goto L16TExeF
If %1==16TComN Goto L16TComN
If %1==16TComS Goto L16TComS
If %1==16TComF Goto L16TComF
If %1==16MLibN Goto L16MLibN
If %1==16MLibS Goto L16MLibS
If %1==16MLibF Goto L16MLibF
If %1==16MObjN Goto L16MObjN
If %1==16MObjS Goto L16MObjS
If %1==16MObjF Goto L16MObjF
If %1==16MExeN Goto L16MExeN
If %1==16MExeS Goto L16MExeS
If %1==16MExeF Goto L16MExeF
If %1==16MComN Goto L16MComN
If %1==16MComS Goto L16MComS
If %1==16MComF Goto L16MComF
Rem Dos 32-Bit
If %1==24MObjN Goto L24MObjN
If %1==24MObjS Goto L24MObjS
If %1==24MObjF Goto L24MObjF
If %1==24MExeN Goto L24MExeN
If %1==24MExeS Goto L24MExeS
If %1==24MExeF Goto L24MExeF
If %1==24MComN Goto L24MComN
If %1==24MComS Goto L24MComS
If %1==24MComF Goto L24MComF
If %1==24MLibN Goto L24MLibN
If %1==24MLibS Goto L24MLibS
If %1==24MLibF Goto L24MLibF
Rem Windows without Resource
If %1==32MExeN Goto L32MExeN
If %1==32MExeS Goto L32MExeS
If %1==32MExeF Goto L32MExeF
If %1==32MCExeN Goto L32MCExeN
If %1==32MCExeS Goto L32MCExeS
If %1==32MCExeF Goto L32MCExeF
If %1==32MObjN Goto L32MObjN
If %1==32MObjS Goto L32MObjS
If %1==32MObjF Goto L32MObjF
If %1==32MOcxN Goto L32MOcxN
If %1==32MOcxS Goto L32MOcxS
If %1==32MOcxF Goto L32MOcxF
If %1==32MDllN Goto L32MDllN
If %1==32MDllS Goto L32MDllS
If %1==32MDllF Goto L32MDllF
If %1==32MLibN Goto L32MLibN
If %1==32MLibS Goto L32MLibS
If %1==32MLibF Goto L32MLibF
Goto EArg

:L16MObjN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16MObjS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16MObjF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm16 /Sa /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16MLibN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /Sa /Sf /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2; >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16MLibS
 Echo Assembling %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm16 /Sa /Sf /c /Cp /nologo /Fl%2.lst %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2; >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16MLibF
 Echo Assembling %2.asm [%2.obj %2.lst %2.map AOut.txt]
 BSM\Bin\Masm16 /Sa /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib %2_2.lst LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2,%2_2.lst >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16MExeN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /Sn /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /INFORMATION /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16MExeS
 Echo Assembling %2.asm [%2.obj %2.map AOut.txt]
 BSM\Bin\Masm16 /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /INFORMATION /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16MExeF
 Echo Assembling %2.asm [%2.obj  %2.lst %2.map AOut.txt]
 BSM\Bin\Masm16 /Sa /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe %2_2.map LOut.txt]
 BSM\Bin\Link16 /MAP /INFORMATION /NOLOGO %2.obj,%2.exe,%2_2.map,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16MComN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /AT /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L16MComS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm16 /AT /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /INFORMATION /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L16MComF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm16 /AT /Sa /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt %2.map]
 BSM\Bin\Link16 /TINY /MAP /INFORMATION /NOLOGO %2.obj,%2.com,%2.map,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L16TExeN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /ml /m9 /z %2.asm,%2.obj >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16TExeS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /l /n /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /INFORMATION /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16TExeF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst]
 BSM\Bin\Tasm16 /c /la /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link16 /MAP /INFORMATION /NOLOGO %2.obj,%2.exe,%2.map,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L16TObjN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /ml /m9 /z %2.asm,%2.obj >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16TObjS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /l /n /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16TObjF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst]
 BSM\Bin\Tasm16 /c /la /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L16TLibN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /ml /m9 /z %2.asm,%2.obj >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2; >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16TLibS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /l /n /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2; >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16TLibF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst]
 BSM\Bin\Tasm16 /c /la /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Libraring: %2.obj [%2.lib %2_2.lst LibOut.txt]
 BSM\Bin\Lib16 %2 /NoLogo +%2,%2_2.lst >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L16TComN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /ml /m9 %2.asm,%2.obj >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L16TComS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Tasm16 /l /n /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /INFORMATION /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L16TComF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Tasm16 /c /la /ml /m9 /z %2.asm,%2.obj,%2.lst >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt %2.map]
 BSM\Bin\Link16 /TINY /MAP /INFORMATION /NOLOGO %2.obj,%2.com,%2.map,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L24MObjN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L24MObjS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L24MObjF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L24MExeN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L24MExeS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link16 /INFORMATION /NOLOGO %2.obj,%2.exe,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L24MExeF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link16 /MAP /INFORMATION /NOLOGO %2.obj,%2.exe,%2.map,,, >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L24MComN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /AT /c /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L24MComS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /AT /Sn /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt]
 BSM\Bin\Link16 /TINY /INFORMATION /NOLOGO %2.obj,%2.com,,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom
:L24MComF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /AT /Sa /Sc /Sf /c /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.com LOut.txt %2.map]
 BSM\Bin\Link16 /TINY /MAP /INFORMATION /NOLOGO %2.obj,%2.com,%2.map,,, >> LOut.txt
 If Not Exist %2.com Goto ELink
 Goto LFinishCom

:L24MLibN
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /nologo /c /omf /Cp %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib LibOut.txt]
 Rem -=- BSM\Bin\Lib32A %2.lib +%2.obj >> LibOut.txt
 BSM\Bin\Lib32 /NOLOGO /OUT:%2.lib %2.obj >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L24MLibS
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /nologo /Sn /c /omf /Cp /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib LibOut.txt]
 Rem -=- BSM\Bin\Lib32A %2.lib +%2.obj >> LibOut.txt
 BSM\Bin\Lib32 /NOLOGO /OUT:%2.lib /VERBOSE %2.obj >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L24MLibF
 Echo Assembling: %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /nologo /Sa /Sc /Sf /c /omf /Cp /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib %2_2.lst LibOut.txt]
 Rem -=- BSM\Bin\Lib32A %2.lib +%2.obj, %2_2.lst >> LibOut.txt
 BSM\Bin\Lib32 /LIST:%2_2.lst /NOLOGO /OUT:%2.lib /VERBOSE %2.obj >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L32MLibN
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib32A %2.lib +%2.obj >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L32MLibS
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib LibOut.txt]
 BSM\Bin\Lib32A %2.lib +%2.obj >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L32MLibF
 Echo Assembling: %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating Library: %2.obj [%2.lib %2_2.lst LibOut.txt]
 BSM\Bin\Lib32A %2.lib +%2.obj, %2_2.lst >> LibOut.txt
 If Not Exist %2.lib Goto ELib
 Goto LExit
:L32MDllN
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating DLL: %2.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MDllS
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo /Fl%2.lst /Sa /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating DLL: %2.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MDllF
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo /Fl%2.lst /Sa /Sc /Sf /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo DLLing: %2.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MOcxN
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Fo%2 /c /coff /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Creating OCX: %2.obj [%2.ocx]
 BSM\Bin\Link32 /NoLogo /Out:%2.ocx /Dll /SubSystem:Windows %2.obj
 If Not Exist %2.ocx Goto EOcx
 Goto LExit
:L32MOcxS
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /Fo%2 /c /coff /nologo /Fl%2.lst /Sa /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo OCXing: %2.obj [%2.ocx]
 BSM\Bin\Link32 /NoLogo /Out:%2.ocx /Dll /SubSystem:Windows %2.obj
 If Not Exist %2.ocx Goto EOcx
 Goto LExit
:L32MOcxF
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /Fo%2 /c /coff /nologo /Fl%2.lst /Sa /Sc /Sf /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo OCXing: %2.obj [%2.ocx]
 BSM\Bin\Link32 /NoLogo /Out:%2.ocx /Dll /SubSystem:Windows %2.obj
 If Not Exist %2.ocx Goto EOcx
 Goto LExit
:L32MObjN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L32MObjS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L32MObjF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Goto LExit
:L32MExeN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MExeS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo /Verbose %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MExeF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link32 /SubSystem:Windows /Entry:BS_Start /Map:%2.map /NoLogo /Verbose %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeN
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /SubSystem:Console /Opt:NoRef /Entry:BS_Start /NoLogo %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeS
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /SubSystem:Console /Opt:NoRef /Entry:BS_Start /NoLogo /Verbose %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeF
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Linking %2.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link32 /SubSystem:Console /Opt:NoRef /Entry:BS_Start /Map:%2.map /NoLogo /Verbose %2.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MDllNRes
 Echo Assembling: %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource: %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource: %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:IX86 /NoLogo %4.res >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo DLLing: %2.obj %4.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj %4.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MDllSRes
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo /Fl%2.lst /Sa /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource: %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 /v %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource: %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Verbose /Machine:IX86 /NoLogo %4.res >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo DLLing: %2.obj %4.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj %4.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MDllFRes
 Echo Assembling: %2.asm [%2.obj %2.lst AOut.txt]
 BSM\Bin\Masm32 /c /coff /nologo /Fl%2.lst /Sa /Sc /Sf /Sl255 %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource: %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 /v %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource: %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Verbose /Machine:IX86 /NoLogo %4.res >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo DLLing: %2.obj %4.obj %2.def [%2.dll %2.exp DllOut.txt]
 BSM\Bin\Link32 /NoLogo /Dll /Def:%2.def /SubSystem:Windows %2.obj %4.obj >> DllOut.txt
 If Not Exist %2.dll Goto EDll
 Goto LExit
:L32MObjNRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Goto LExit
:L32MObjSRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Goto LExit
:L32MObjFRes
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 /v %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /Verbose /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Goto LExit
:L32MExeNRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MExeSRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
  Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo /Verbose %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MExeFRes
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 /v %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /Machine:x86 /Verbose /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link32 /SubSystem:Windows /Entry:BS_Start /Map:%2.map /NoLogo /Verbose %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeNRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /c /coff /Cp /nologo %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /SubSystem:Console /Opt:NoRef /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeSRes
 Echo Assembling %2.asm [%2.obj AOut.txt]
 BSM\Bin\Masm32 /Sn /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
  Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /SubSystem:Console /Opt:NoRef /Machine:x86 /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt]
 BSM\Bin\Link32 /Entry:BS_Start /NoLogo /Verbose %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe
:L32MCExeFRes
 Echo Assembling %2.asm [%2.obj AOut.txt %2.lst %2.map]
 BSM\Bin\Masm32 /Sa /Sc /Sf /c /coff /Cp /nologo /Fl%2.lst /Fm%2.map %2.asm >> AOut.txt
 If Not Exist %2.obj Goto EAsm
 Echo Compiling Resource %4.rc [%4.res CpOut.txt]
 BSM\Bin\Rc32 /v %4.rc >> CpOut.txt
 If Not Exist %4.res Goto ECompRes
 Echo Converting Resource %4.res [%4.obj CvOut.txt]
 BSM\Bin\CvtRes32 /SubSystem:Console /Opt:NoRef /Machine:x86 /Verbose /NoLogo %4 >> CvOut.txt
 If Not Exist %4.obj Goto EConvRes
 Echo Linking %2.obj %4.obj [%2.exe LOut.txt %2.map]
 BSM\Bin\Link32 /SubSystem:Windows /Entry:BS_Start /Map:%2.map /NoLogo /Verbose %2.obj %4.obj >> LOut.txt
 If Not Exist %2.exe Goto ELink
 Goto LFinishExe

Rem -=- Finish Runners -=-
:LFinishExe
 If %3==y %2.exe
 If %3==Y %2.exe
 Goto LExit
:LFinishCom
 If %3==y %2.com
 If %3==Y %2.com
 Goto LExit

Rem -=- Error Labels -=-
:EArg
 Echo Asm: Parameter Error
 Goto LExit
:EAsm
 Echo Assembling: Error
 Goto LExit
:ELink
 Echo Linking: Error
 Goto LExit
:ECompRes
 Echo Resource Compiling: Error
 Goto LExit
:EConvRes
 Echo Resource Converting: Error
 Goto LExit
:ELib
 Echo Creating Library: Error
 Goto LExit
:EOcx
 Echo Creating Ocx: Error
 Goto LExit
:ENoResFile
 Echo Asm: Error [Resource File Not Found]
 Goto LExit
:ENoAsmFile
 Echo Asm: Error [Assembly File Not Found]
 Goto LExit

Rem -=- Exit Label -=-
:LExit
